#!/bin/sh

##
# This script is used to run the test client applications.
# Call this script with the name of the client application you wish
# to run.
#          ex: ./runtest.sh GetApplicationListTest
#
# Listed below are test names that you can run.
#
# GetApplicationListTest
# AssignAgencyTrackingNumTest
# ConfirmApplicationDeliveryTest
# GetApplicationTest
# GetApplicationZipTest
##

##
# Variables that you should change to suit your environment.
##
JAVA_HOME=/usr/j2se
LIB=/export/home/dwong/agencyClient/lib
CLIENTJAR=/export/home/dwong/agencyClient/agency-s2s-client.jar
CP_SEP=':'
COMMONJAR=/export/home/dwong/temp/s2s-commons.jar
CLASSES=/export/home/dwong/agencyClient/classes

##
# Variable that you don't need to change.
##
PACKAGE=gov.grants.apply.agency
JAVAOPTS=-Djava.protocol.handler.pkgs=com.sun.net.ssl.internal.www.protocol
#JAVAOPTS="${JAVAOPTS} -Djavax.net.debug=ssl,handshake"

##
# Creating a classpath from the contents of your lib directory
##
MYCP=`find ${LIB} -name '*.jar' -type f | sort | paste -d${CP_SEP} -s -`
MYCP=${MYCP}${CP_SEP}${CLASSES}${CP_SEP}${CLASSES}${CP_SEP}${CLIENTJAR}${CP_SEP}${COMMONJAR}
echo ${MYCP}

##
# Use WSTestClient as the default application to run if no
# no arguments was provided.
##
if [ $# -eq 0 ] 
then
   CLASS=${PACKAGE}.WSTestClient
else
   CLASS=${PACKAGE}.$1
   shift
fi
echo Running ${CLASS}

##
# Run the test application with all other arguments after the first.
##
${JAVA_HOME}/bin/java -classpath ${MYCP} ${JAVAOPTS} ${CLASS} $@


