/*
 * Created on Jun 21, 2004
 *
 */
package gov.grants.apply.util;

import java.util.Iterator;

import javax.servlet.http.HttpServletRequest;

import org.apache.axis.AxisFault;
import org.apache.axis.Message;
import org.apache.axis.MessageContext;
import org.apache.axis.attachments.AttachmentPart;
import org.apache.axis.attachments.Attachments;
import org.apache.axis.transport.http.HTTPConstants;
import org.apache.log4j.Logger;

/**
 * This an utility class for Axis.
 * 
 * @author Brian Husted
 *  
 */
public class AxisUtils
{
   static final Logger log = Logger.getLogger(AxisUtils.class.getName());

   /**
    * @return the AttachmentPart array
    * @throws AxisFault
    */
   public static AttachmentPart[] getMessageAttachments() throws AxisFault
   {
      MessageContext msgContext = MessageContext.getCurrentContext();
      Message reqMsg = msgContext.getRequestMessage();
      Attachments messageAttachments = reqMsg.getAttachmentsImpl();

      if (null == messageAttachments)
      {
         log.debug("no attachment support");
         return new AttachmentPart[0];
      }
      int attachmentCount = messageAttachments.getAttachmentCount();
      AttachmentPart attachments[] = new AttachmentPart[attachmentCount];
      Iterator it = messageAttachments.getAttachments().iterator();
      int count = 0;
      while (it.hasNext())
      {
         AttachmentPart part = (AttachmentPart) it.next();
         attachments[count++] = part;
      }
      return attachments;
   }

   public static HttpServletRequest getCurrentHttpRequest()
   {
      HttpServletRequest request = (HttpServletRequest) MessageContext.getCurrentContext()
            .getProperty(HTTPConstants.MC_HTTP_SERVLETREQUEST);
      request.getSession(true);
      return request;
   }

}