/*
 * Created on Jun 7, 2005
 *
 * Unpublished Work, Copyright, 2005 Northrop Grumman
 */
package gov.grants.apply.ws.production;

import gov.grants.apply.WebServices.AgencyIntegrationServices_V1_0.AssignAgencyTrackingNumberRequest;
import gov.grants.apply.WebServices.AgencyIntegrationServices_V1_0.AssignAgencyTrackingNumberResponse;
import gov.grants.apply.WebServices.AgencyIntegrationServices_V1_0.ResponseMessage;
import gov.grants.apply.util.AxisUtils;
import gov.grants.apply.util.ProcessorUtils;
import gov.grants.apply.ws.IAssignAgencyTrackingNumberProcessor;
import gov.grants.apply.ws.ProcessorException;

import org.apache.log4j.Logger;

import com.trw.InFlowSuiteCustomization.Grants_gov.CustomerDefinedClasses.GGWSWrapper;

/**
 * @author Grants.gov WebServices Team
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public final class AssignAgencyTrackNumProdModeProcessor
   implements IAssignAgencyTrackingNumberProcessor
{
   private static final Logger LOG = Logger.getLogger(AssignAgencyTrackNumProdModeProcessor.class);

   /* (non-Javadoc)
    * @see gov.grants.apply.ws.IAssignAgencyTrackingNumberProcessor#process(gov.grants.apply.WebServices.AgencyIntegrationServices_V1_0.AssignAgencyTrackingNumberRequest)
    */
   public AssignAgencyTrackingNumberResponse process(AssignAgencyTrackingNumberRequest request)
      throws ProcessorException
   {
      String ggTrackNum = request.getGrants_govTrackingNumber();
      String agencyTrackNum = request.getAgencyTrackingNumber();
      
      if (ggTrackNum == null || agencyTrackNum == null)
      {
         throw new ProcessorException("Neither the Grants.gov or the Agency assigned tracking numbers can be null");
      }
      try
      {
         GGWSWrapper.assignAgencyTrackingNumber(GGWSWrapper.getID(AxisUtils.getCurrentHttpRequest()), ggTrackNum, agencyTrackNum);
      }
      catch (Exception e)
      {
         throw new ProcessorException("Failed to assign agency tracking number.", e);
         //return ProcessorUtils.prepareAssignAgencyTrackingNumberResponse(ResponseMessage.Failure, ggTrackNum);
      }
      return ProcessorUtils.prepareAssignAgencyTrackingNumberResponse(ResponseMessage.Success, ggTrackNum);
   }

}
