/*
 * Created on Jun 7, 2005
 *
 * Unpublished Work, Copyright, 2005 Northrop Grumman
 */
package gov.grants.apply.ws.production;

import gov.grants.apply.WebServices.AgencyIntegrationServices_V1_0.EncodingTypeEnum;
import gov.grants.apply.WebServices.AgencyIntegrationServices_V1_0.GetApplicationZipRequest;
import gov.grants.apply.WebServices.AgencyIntegrationServices_V1_0.GetApplicationZipResponse;
import gov.grants.apply.util.AxisUtils;
import gov.grants.apply.util.ProcessorUtils;
import gov.grants.apply.ws.GetApplicationZipBean;
import gov.grants.apply.ws.IGetApplicationProcessor;
import gov.grants.apply.ws.IGetApplicationZipProcessor;
import gov.grants.apply.ws.ProcessorException;

import org.apache.axis.types.URI.MalformedURIException;
import org.apache.log4j.Logger;

import com.trw.InFlowSuiteCustomization.Grants_gov.CustomerDefinedClasses.GGWSWrapper;

/**
 * @author Grants.gov WebServices Team
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public final class GetApplicationZipProdModeProcessor
   implements IGetApplicationZipProcessor
{
   private static final Logger LOG = Logger.getLogger(GetApplicationZipProdModeProcessor.class);

   /* (non-Javadoc)
    * @see gov.grants.apply.ws.IGetApplicationZipProcessor#process(gov.grants.apply.WebServices.AgencyIntegrationServices_V1_0.GetApplicationZipRequest)
    */
   public final GetApplicationZipResponse process(GetApplicationZipRequest request)
         throws ProcessorException
   {
      String trackingNum = request.getGrants_govTrackingNumber();
      if (trackingNum == null || "".equals(trackingNum))
      {
         throw new ProcessorException("Tracking number is null or blank.");
      }
      EncodingTypeEnum encodingType = request.getEncodingType();
      String encoding = IGetApplicationProcessor.DEFAULT_ENCODING_TYPE;
      if (encodingType != null)
      {
         encoding = encodingType.getValue();
      }
      byte[] zip = null;
      try
      {
         zip = GGWSWrapper.getApplicationZip(GGWSWrapper.getID(AxisUtils.getCurrentHttpRequest()), trackingNum);
      }
      catch (Exception e)
      {
         LOG.debug("Failed to get application zip.", e);
         throw new ProcessorException("Failed to get application zip.", e);
      }
      GetApplicationZipBean bean = new GetApplicationZipBean();
      bean.setEncodingType(encoding);
      String name = "cid:" + trackingNum + ".zip";
      try
      {
         bean.setFileLocation(name);
      }
      catch (MalformedURIException e)
      {
         throw new ProcessorException(e);
      }
      bean.setZipBytes(zip, name);
      return ProcessorUtils.prepareGetApplicationZipResponse(bean);
   }

}
