/*
 * Created on Jun 3, 2005
 *
 * Unpublished Work, Copyright, 2005 Northrop Grumman
 */
package gov.grants.apply.ws.standAloneMode;

import gov.grants.apply.WebServices.AgencyIntegrationServices_V1_0.GrantsGovApplicationStatusType;
import gov.grants.apply.dao.Application;
import gov.grants.apply.ws.IGetApplicationListBean;

import java.util.Calendar;

/**
 * @author Grants.gov WebServices Team
 *
 * Wrapper for Application class from DAO component.
 */
public final class ApplicationInfoFromDAO implements IGetApplicationListBean
{
   private Application _app = null;
   
   public ApplicationInfoFromDAO(Application app)
   {
      _app = app;
   }
   
   /* (non-Javadoc)
    * @see gov.grants.apply.ws.IGetApplicationListBean#getCfdaNumber()
    */
   public String getCfdaNumber()
   {
      return _app.getHeader().getCfdaNumber();
   }

   /* (non-Javadoc)
    * @see gov.grants.apply.ws.IGetApplicationListBean#getCompetitionId()
    */
   public String getCompetitionId()
   {
      return _app.getHeader().getCompetitionID();
   }

   /* (non-Javadoc)
    * @see gov.grants.apply.ws.IGetApplicationListBean#getOpportunityNumber()
    */
   public String getOpportunityNumber()
   {
      return _app.getHeader().getOpportunityID();
   }

   /* (non-Javadoc)
    * @see gov.grants.apply.ws.IGetApplicationListBean#getStatus()
    */
   public GrantsGovApplicationStatusType getStatus()
   {
      return _app.getApplicationStatus();
   }

   /* (non-Javadoc)
    * @see gov.grants.apply.ws.IGetApplicationListBean#getSubmissionTitle()
    */
   public String getSubmissionTitle()
   {
      return _app.getHeader().getSubmissionTitle();
   }

   /* (non-Javadoc)
    * @see gov.grants.apply.ws.IGetApplicationListBean#getTrackingNumber()
    */
   public String getTrackingNumber()
   {
      return _app.getFooter().getGrantsGovTrackingNumber();
   }

   public Calendar getReceivedDate()
   {
      return _app.getFooter().getReceivedDateTime();
   }
}
